package moe.oko.opennaw;

import moe.oko.opennaw.command.NationCommand;
import moe.oko.opennaw.util.ChatHandler;
import moe.oko.opennaw.util.CityHandler;
import moe.oko.opennaw.util.GroupHandler;
import moe.oko.opennaw.util.NationHandler;
import net.luckperms.api.LuckPerms;
import org.bukkit.plugin.java.JavaPlugin;

import static moe.oko.opennaw.util.CommandHelper.info;

public final class OpenNAW extends JavaPlugin {

    public static OpenNAW instance;
    public NationHandler nationHandler;
    public CityHandler cityHandler;
    public GroupHandler groupHandler;
    private LuckPerms luckPerms;

    public static OpenNAW getInstance() {
        return instance;
    }

    public NationHandler getNationHandler() {
        return nationHandler;
    }
    public CityHandler getCityHandler(){ return cityHandler; }
    public GroupHandler getGroupHandler() { return groupHandler; }

    @Override
    public void onEnable() {
        // Initialize internals
        instance = this;
        this.luckPerms = getServer().getServicesManager().load(LuckPerms.class);
        nationHandler = new NationHandler();
        groupHandler = new GroupHandler(this.luckPerms);

        info("OpenNAW is enabled!");

        // Register Commands & Events
        this.getCommand("nation").setExecutor(new NationCommand());
        getServer().getPluginManager().registerEvents(new ChatHandler(), this);
    }

    @Override
    public void onDisable() {
        info("OpenNAW is disabled!");
    }

}
